package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallOrderLogApplicationService;
import com.jeesharp.business.modules.mall.dto.MallOrderLogSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallOrderLogListVO;
import com.jeesharp.business.modules.mall.vo.MallOrderLogInfoVO;
import com.jeesharp.business.modules.mall.vo.MallOrderLogQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 订单状态日志管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/orderLog/v1")
@Tag(name = "订单状态日志管理")
@AllArgsConstructor
public class MallOrderLogController extends BaseController {

    private final MallOrderLogApplicationService mallOrderLogApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallOrderLogInfoVO> info(@RequestParam("id") String id) {
        MallOrderLogInfoVO vo = mallOrderLogApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallOrderLogListVO>> list(@RequestBody MallOrderLogQueryVO query) {
        PageRespVO<MallOrderLogListVO> page = mallOrderLogApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallOrderLogSaveDTO dto) {
        mallOrderLogApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallOrderLogApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
